git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Ruud van Asseldonk <dev@veniogames.com>
To: git@vger.kernel.org
Cc: Paolo Bonzini <pbonzini@redhat.com>,
	Jonathan Nieder <jrnieder@gmail.com>
Subject: [PATCH] t5150: skip request-pull test if Perl is disabled
Date: Tue, 26 Nov 2019 01:02:46 +0100	[thread overview]
Message-ID: <4f11b5b3-a68e-642a-c5fb-7b5dae698669@veniogames.com> (raw)

The git-request-pull.sh script invokes Perl, so it requires Perl to be
available, but the associated test t5150 does not skip itself when Perl
has been disabled, which then makes subtest 4 through 10 fail. Subtest 3
still passes, but for the wrong reasons (it expects git-request-pull to
fail, and it does fail when Perl is not available). The initial two
subtests that do pass are only doing setup.

To prevent t5150 from failing the build when NO_PERL=1, add a check that
sets skip_all when "! test_have_prereq PERL", just like how for example
t3701-add-interactive skips itself when Perl has been disabled.

Signed-off-by: Ruud van Asseldonk <dev@veniogames.com>
---
I discovered this issue in the Git package in Nixpkgs. The Nix package
manager tries to make it hard to accidentally introduce undeclared
dependencies, and it has a sandbox that hides things in /usr/bin. So
when it builds with NO_PERL=1, it really makes no Perl available, so you
cannot accidentally depend on the Perl in /usr/bin/perl. For the tests
it does set PERL_PATH, but it does not point to a binary in /usr/bin.

 t/t5150-request-pull.sh | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/t/t5150-request-pull.sh b/t/t5150-request-pull.sh
index 852dcd913f..1ad4ecc29a 100755
--- a/t/t5150-request-pull.sh
+++ b/t/t5150-request-pull.sh
@@ -4,6 +4,12 @@ test_description='Test workflows involving pull request.'
 
 . ./test-lib.sh
 
+if ! test_have_prereq PERL
+then
+	skip_all='skipping request-pull tests, perl not available'
+	test_done
+fi
+
 test_expect_success 'setup' '
 
 	git init --bare upstream.git &&
-- 
2.24.0

             reply	other threads:[~2019-11-26  0:08 UTC|newest]

Thread overview: 11+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-11-26  0:02 Ruud van Asseldonk [this message]
2019-11-26  0:43 ` [PATCH] t5150: skip request-pull test if Perl is disabled Jonathan Nieder
2019-11-26  0:46 ` Jonathan Nieder
2019-11-27 22:42   ` Ruud van Asseldonk
2019-11-27 11:21 ` Jeff King
2019-11-27 23:45   ` Ruud van Asseldonk
2019-11-28  1:35     ` Jonathan Nieder
2019-11-28  1:31   ` Jonathan Nieder
2019-12-02  6:19     ` Junio C Hamano
2019-12-13  7:46       ` Jeff King
2019-12-16 18:32         ` Junio C Hamano

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=4f11b5b3-a68e-642a-c5fb-7b5dae698669@veniogames.com \
    --to=dev@veniogames.com \
    --cc=git@vger.kernel.org \
    --cc=jrnieder@gmail.com \
    --cc=pbonzini@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).